#ifndef FWSTRGAR_H
#define FWSTRGAR_H
//========================================================================================
//
//	File:				FWStrgAr.h
//	Release Version:	$ 1.0d1 $
//
//	Creation Date:		3/28/94
//
//	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWSTRS_H
#include "FWStrs.h"
#endif

//========================================================================================
//	Forward class declarations
//========================================================================================

class FW_CReadableArchive;
class FW_CWritableArchive;


//========================================================================================
//	CLASS FW_CStringArchiver
//========================================================================================

class FW_CStringArchiver
{
public:

	static void Read(FW_CReadableArchive & archive,
						FW_CString &string);

	static void Write(FW_CWritableArchive & archive, 
					  const FW_CString &string);
};


//========================================================================================
//	Template FW_TStringArchiver
//========================================================================================

template <class tString>
class FW_TStringArchiver
{

public:

	static void * Read(FW_CReadableArchive & archive);
		// Read function for FW_REGISTER_ARCHIVE_CLASS macro.

	static void Write(FW_CWritableArchive & archive, 
					  const void *object);
		// Write function for FW_REGISTER_ARCHIVE_CLASS macro.
};


//========================================================================================
// FW_InitializeStrings
//========================================================================================

void FW_InitializeStrings(void);

#endif